openr,2,'omega_path'
datapath=''
geompath=''
readf,2,datapath
readf,2,geompath
close,2
nomfic=' '
start:
print,'OMEGA observation: '
read,nomfic
nomgeo=nomfic+'.NAV'
nomfic=nomfic+'.QUB'
nomfic=datapath+nomfic
openr,2,nomfic,ERROR=errflag
close,2
if (errflag ne 0) then begin
  print,'file ',nomfic,' not found'
  goto, start
endif
readcube, nomfic, idat, sdat0, sdat1,info
exposure=0
exposure=info(0:2)
summation=info(3)
bits_per_data=info(4)
nomgeo=geompath+nomgeo

openr,1,nomgeo,ERROR=errflag
if(errflag ne 0) then begin
  print,' no corresponding NAV cube'
  close,1
  dmars=1.52
  specmars=fltarr(352)
  openr,2,'specsol_0403.dat'
  readf,2,specmars
  close,2
  specmars=specmars/dmars/dmars     
  goto, nogeom
endif
trans= !pi/180.*1.e-4

geocube=0B
ilec=0B

read_geolbl,nomgeo, '', values, data

lrec   = data(0)
nrec   = data(1)
npixel = data(2)
npara  = data(3)
nscan  = data(4)
nau    = data(5)
dmars=nau*1.e-4
close,2
openr,2,'specsol_0403.dat'
specmars=0B
specmars=fltarr(352)
readf,2,specmars
close,2
specmars=specmars/dmars/dmars

data = 0B
geocube=0B

geocube = lonarr(npixel, npara, nscan)
ilec = lonarr(npixel)

point_lun,1,lrec*nrec

for  k=0,nscan-1 do begin
   for j=0,npara-1 do begin
      readu, 1, ilec
      geocube(*,j,k) = ilec
   endfor
endfor
close, 1
if(geocube(1,1,0) gt 13) then geocube=swap_endian(temporary(geocube))
longi=reform(geocube(*,6,*)*1.e-4)
lati=reform(geocube(*,7,*)*1.e-4)
alt=reform(geocube(*,12,*)*1.e-3)
nogeom: 
close,/all
; preliminary pipeline tool
; may 2004 version: the visible data, jdat(*,256:*,*) is divided by
; two if the scan length is 128 pixels (there are then 2 VIS acquisitions 
; per scan)

a=size(idat)
nbal=a(3)
indi=where(sdat1(14,1,*) ge 6 and sdat0(10,*) gt 100)
npix=a(1)
jdat=0
jdat=float(idat)
sdats=0
sdats=float(sdat0(0:255,*))
ndeb=min(indi)
indj=ndeb+indgen(nbal-ndeb)
for k=0,255 do begin
  a=poly_fit(indi,sdats(k,indi),2,b)
  sdats(k,indi)=b-sdat0(k,indi) 
  for i=0,npix-1 do jdat(i,k,ndeb:nbal-1)=jdat(i,k,ndeb:nbal-1)+sdats(k,ndeb:nbal-1)
endfor

if(summation ne 1) then jdat=jdat/summation
if(npix eq 128) then jdat(*,256:*,*)=0.5*jdat(*,256:*,*)
if(exposure(2) gt 50.) then jdat(*,256:*,*)=jdat(*,256:*,*)*50./exposure(2)
linearC=0
linearC=fltarr(4096)
openr,2,'linearC.dat'
readf,2,linearC
close,2
jdat(*,0:127,*)=linearC(fix(jdat(*,0:127,*)+0.5))
wvl=0
wvl=fltarr(352)
openr,2,'lambda_0403.dat'
readf,2,wvl
close,2
mtf=fltarr(352)
openr,2,'mtf040324_50.dat'
if(exposure(0) lt 4.) then begin
  close,2
  openr,2,'mtf040324_25.dat'
endif
readf,2,mtf
close,2
for n=0,351 do jdat(*,n,*)=jdat(*,n,*)/mtf(n)
close,/all
end
